; Multiplier.asm for NASM

; Demonstrates initialised data

; VB
; Declare Function MulConst Lib "Multiplier.dll" _
; (ByVal Y As Single) As Single

; Use
; Y = 1.5
; answer = MulConst(Y) 

[SECTION .data]
Const dd  3.66

SEGMENT code Use32
GLOBAL _DllMain
_DllMain:
    mov eax,1
ret 12

GLOBAL MulConst
MulConst:

    push ebp
    mov ebp,esp
    push esi
    push edi
    push ebx
    ;--------------------------------------------------------------
                            ; ST0   ST1
    fld dword [ebp+8]       ; Y
    fld dword [Const]       ; Const  Y
    fmulp ST1               ; Y*Const, pop
    
    ; NB Single result left in ST0
    
    ;--------------------------------------------------------------
    pop ebx
    pop edi
    pop esi
    mov esp,ebp
    pop ebp
ret 4
