; LongFunc.asm for NASM

; Demonstrates long output to Function DLL
; multiplies a number by 2 using the FPU

; VB
; Declare Function LongFunc Lib "LongFunc.dll" _
; (ByVal A As Long) As Long

; Use
; A = long integer
; answer = LongFunc(A) 


SEGMENT code Use32
GLOBAL _DllMain
_DllMain:
    mov eax,1
ret 12

%Define Ans [ebp-4]

GLOBAL LongFunc
LongFunc:

    push ebp
    mov ebp,esp
    sub esp,4
    push esi
    push edi
    push ebx
    ;--------------------------------------------------------------
                            ; ST0   ST1
    fild dword [ebp+8]      ; A
    fild dword [ebp+8]      ; A     A
    faddp ST1               ; 2A, pop
    fistp dword Ans         ; 2A-> Ans, pop clears FPU stack

    mov eax,Ans    
    ; Answer in eax NOT ST0 as previous example
    ;--------------------------------------------------------------
    pop ebx
    pop edi
    pop esi
    mov esp,ebp
    pop ebp
ret 4
