; SimpleDll.asm   For NASM

; ' VB 

; Private Declare Sub Addlongs Lib "SimpleDLL" _
; (ByRef num1 As Long, ByVal num2 As Long)
; ' Use
; Dim num1 as Long, num2 as Long
; num1 = 200: num2 = 5 ' say
; Addlongs num1, num2
; ' num1 will = 205

; Standard Win32 Start

SEGMENT code Use32
GLOBAL _DllMain
_DllMain:   
    mov eax,1
ret 12                  ; This produces a Link Warning, but can be ignored!

; All exported items need A GLOBAL declaration
; followed by a matching Label

GLOBAL Addlongs
Addlongs:
    
    push ebp            ; Enter 0,0 can be used for these 2 lines but I
    mov ebp,esp         ; prefer the more explicit, which is also faster
    
    ; In general also need
    push esi
    push edi
    push ebx
    ;--------------------------------------------------------------

    mov ebx,[ebp+8]     ; ptr to num1 NB ByRef
    mov eax,[ebx]       ; eax=num1
    add eax,[ebp+12]    ; [ebp+12]=num2 NB ByVal
    mov [ebx],eax       ; answer in num1

    ;--------------------------------------------------------------
    ; and:-
    pop ebx
    pop edi
    pop esi
    
    mov esp,ebp         ; Leave can be used for these 2 lines
    pop ebp
    
ret 8       ; 8 bytes for 2 long parameters in DLL