; SineCosine.asm for NASM

; Demonstrates using the FPU

; VB
; Declare Sub SineCosine Lib "SineCosine.dll" _
; ByVal Angle As Single, ByRef Sine As Single, ByRef Cosine As Single)
; Use:- 
; SineCosine Angle, Sine, Cosine

SEGMENT code Use32
GLOBAL _DllMain
_DllMain:
    mov eax,1
ret 12

GLOBAL SineCosine
SineCosine:

    push ebp
    mov ebp,esp
    push esi
    push edi
    push ebx
    ;--------------------------------------------------------------

    fld dword [ebp+8]   ; Angle
    fsincos             ; cos | sin
    mov ebx,[ebp+16]    ; Ptr to Cosine
    fstp dword [ebx]
    mov ebx,[ebp+12]    ; Ptr to Sine
    fstp dword [ebx]

    ;--------------------------------------------------------------
    pop ebx
    pop edi
    pop esi
    mov esp,ebp
    pop ebp

ret 12      ; 12 bytes for 3x4B parameters in DLL

