VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   Caption         =   "ATan2"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   213
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   312
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' ATan2.frm

' DLL to find ATan2

' Demonstrates a Function DLL
' Here result from ASM is in FPU register ST0
' and this is transferred to the result
' of the DLL

Private Declare Function ATan2 Lib "ATan2.dll" _
 (ByVal Y As Single, ByVal X As Single) As Double

Const pi# = 3.14159265

Private Sub Form_Load()

Dim Y As Single
Dim X As Single
Dim zatan As Double 'Single

Print "Testing ATan2 DLL"
Print

Y = 1
X = 2
zatan = ATan2(Y, X)

Print "Y/X = "; Y; "/"; X
Print "ASM ATan2(Y/X) = "; zatan
Print
Print "VB   ATan2(Y/X) = "; VBzATan2(Y, X)
Print
Print "VB   Atn(Y/X) = "; Atn(Y / X)


End Sub

Public Function VBzATan2(ByVal Y, ByVal X) As Double 'Single
'Global pi#
If X <> 0 Then
   VBzATan2 = Atn(Y / X)
   If (X < 0) Then
      If (Y < 0) Then VBzATan2 = VBzATan2 - pi# Else VBzATan2 = VBzATan2 + pi#
   End If
Else
   If Abs(Y) > Abs(X) Then   'Must be an overflow
      If Y > 0 Then VBzATan2 = pi# / 2 Else VBzATan2 = -pi# / 2
   Else
      VBzATan2 = 0   'Must be an underflow
   End If
End If
End Function

